commit 1f869543aef61fb646abe72ef1a6b38312acec48
Author: David Friesecký <frieseck@students.zcu.cz>
Date:   Fri Apr 30 12:31:36 2021 +0200

    Re #8590 - Modified tests due to fields of subject implemented

diff --git a/tests/integration_tests/dao/certificate_repository_test.py b/tests/integration_tests/dao/certificate_repository_test.py
index 9bf116f..a3ec666 100644
--- a/tests/integration_tests/dao/certificate_repository_test.py
+++ b/tests/integration_tests/dao/certificate_repository_test.py
@@ -9,15 +9,22 @@ def test_create(certificate_repository, private_key_repository_unique):
     private_key_id = private_key_repository_unique.create(private_key=private_key)
 
     assert type(private_key_id) is int
+    print(f"{type(private_key.private_key)}: >{private_key.private_key}<")
+
+    certificate_1 = Certificate(certificate_id=-1, valid_from="test_from_1", valid_to="test_to_1",
+                                pem_data="test_pem_data_1", common_name="test_create_1", country_code="test_C",
+                                locality="test_L", province="test_ST", organization="test_O",
+                                organizational_unit="test_OU", email_address="test_Mail", type_id=ROOT_CA_ID,
+                                parent_id=-1, private_key_id=private_key_id, usages={CA_ID: True})
+
+    print(f"{type(certificate_1.common_name)}: >{certificate_1.common_name}<")
+    print(f"{type(certificate_1.country_code)}: >{certificate_1.country_code}<")
 
-    certificate_1 = Certificate(certificate_id=-1, common_name="test_create_1", valid_from="test_from_1",
-                                valid_to="test_to_1", pem_data="test_pem_data_1", private_key_id=private_key_id,
-                                type_id=ROOT_CA_ID, parent_id=-1, usages={CA_ID: True})
     certificate_id_1 = certificate_repository.create(certificate=certificate_1)
 
-    certificate_2 = Certificate(certificate_id=-1, common_name="test_create_2", valid_from="test_from_2",
-                                valid_to="test_to_2", pem_data="test_pem_data_2", private_key_id=private_key_id,
-                                type_id=INTERMEDIATE_CA_ID, parent_id=certificate_id_1,
+    certificate_2 = Certificate(certificate_id=-1, valid_from="test_from_2", valid_to="test_to_2",
+                                pem_data="test_pem_data_2", common_name="test_create_2", type_id=INTERMEDIATE_CA_ID,
+                                parent_id=certificate_id_1, private_key_id=private_key_id,
                                 usages={CA_ID: True, SSL_ID: True})
     certificate_id_2 = certificate_repository.create(certificate=certificate_2)
 
@@ -28,32 +35,46 @@ def test_create(certificate_repository, private_key_repository_unique):
     certificate_2 = certificate_repository.read(certificate_id=certificate_id_2)
 
     assert certificate_1.certificate_id == certificate_id_1
-    assert certificate_1.common_name == "test_create_1"
     assert certificate_1.valid_from == "test_from_1"
     assert certificate_1.valid_to == "test_to_1"
-    assert certificate_1.private_key_id == private_key_id
+    assert certificate_1.pem_data == "test_pem_data_1"
     assert certificate_1.type_id == ROOT_CA_ID
     assert certificate_1.parent_id == certificate_id_1
+    assert certificate_1.private_key_id == private_key_id
+    assert certificate_1.common_name == "test_create_1"
+    assert certificate_1.country_code == "test_C"
+    assert certificate_1.locality == "test_L"
+    assert certificate_1.province == "test_ST"
+    assert certificate_1.organization == "test_O"
+    assert certificate_1.organizational_unit == "test_OU"
+    assert certificate_1.email_address == "test_Mail"
+    assert certificate_1.revocation_date is None
+    assert certificate_1.revocation_reason is None
     assert certificate_1.usages[CA_ID]
     assert not certificate_1.usages[SSL_ID]
     assert not certificate_1.usages[SIGNATURE_ID]
     assert not certificate_1.usages[AUTHENTICATION_ID]
-    assert certificate_1.revocation_date == ""
-    assert certificate_1.revocation_reason == ""
 
     assert certificate_2.certificate_id == certificate_id_2
-    assert certificate_2.common_name == "test_create_2"
     assert certificate_2.valid_from == "test_from_2"
     assert certificate_2.valid_to == "test_to_2"
-    assert certificate_2.private_key_id == private_key_id
+    assert certificate_2.pem_data == "test_pem_data_2"
     assert certificate_2.type_id == INTERMEDIATE_CA_ID
     assert certificate_2.parent_id == certificate_id_1
+    assert certificate_2.private_key_id == private_key_id
+    assert certificate_2.common_name == "test_create_2"
+    assert certificate_2.country_code is None
+    assert certificate_2.locality is None
+    assert certificate_2.province is None
+    assert certificate_2.organization is None
+    assert certificate_2.organizational_unit is None
+    assert certificate_2.email_address is None
+    assert certificate_2.revocation_date is None
+    assert certificate_2.revocation_reason is None
     assert certificate_2.usages[CA_ID]
     assert certificate_2.usages[SSL_ID]
     assert not certificate_2.usages[SIGNATURE_ID]
     assert not certificate_2.usages[AUTHENTICATION_ID]
-    assert certificate_2.revocation_date == ""
-    assert certificate_2.revocation_reason == ""
 
 
 def test_read(certificate_repository, private_key_repository_unique):
@@ -62,9 +83,9 @@ def test_read(certificate_repository, private_key_repository_unique):
 
     assert type(private_key_id) is int
 
-    certificate = Certificate(certificate_id=-1, common_name="test_read", valid_from="test_from",
-                              valid_to="test_to", pem_data="test_pem_data", private_key_id=private_key_id,
-                              type_id=ROOT_CA_ID, parent_id=-1, usages={CA_ID: True})
+    certificate = Certificate(certificate_id=-1, valid_from="test_from", valid_to="test_to", pem_data="test_pem_data",
+                              common_name="test_read", type_id=ROOT_CA_ID, parent_id=-1, private_key_id=private_key_id,
+                              usages={CA_ID: True})
     certificate_id = certificate_repository.create(certificate=certificate)
 
     assert type(certificate_id) is int
@@ -72,18 +93,25 @@ def test_read(certificate_repository, private_key_repository_unique):
     certificate = certificate_repository.read(certificate_id=certificate_id)
 
     assert certificate.certificate_id == certificate_id
-    assert certificate.common_name == "test_read"
     assert certificate.valid_from == "test_from"
     assert certificate.valid_to == "test_to"
-    assert certificate.private_key_id == private_key_id
+    assert certificate.pem_data == "test_pem_data"
     assert certificate.type_id == ROOT_CA_ID
     assert certificate.parent_id == certificate_id
+    assert certificate.private_key_id == private_key_id
+    assert certificate.common_name == "test_read"
+    assert certificate.country_code is None
+    assert certificate.locality is None
+    assert certificate.province is None
+    assert certificate.organization is None
+    assert certificate.organizational_unit is None
+    assert certificate.email_address is None
+    assert certificate.revocation_date is None
+    assert certificate.revocation_reason is None
     assert certificate.usages[CA_ID]
     assert not certificate.usages[SSL_ID]
     assert not certificate.usages[SIGNATURE_ID]
     assert not certificate.usages[AUTHENTICATION_ID]
-    assert certificate.revocation_date == ""
-    assert certificate.revocation_reason == ""
 
 
 def test_read_invalid_id(certificate_repository, private_key_repository_unique):
@@ -108,9 +136,9 @@ def test_update(certificate_repository, private_key_repository_unique):
 
     assert type(private_key_id) is int
 
-    certificate = Certificate(certificate_id=-1, common_name="test_update_before", valid_from="test_from",
-                              valid_to="test_to", pem_data="test_pem_data", private_key_id=private_key_id,
-                              type_id=ROOT_CA_ID, parent_id=-1, usages={CA_ID: True})
+    certificate = Certificate(certificate_id=-1, valid_from="test_from", valid_to="test_to", pem_data="test_pem_data",
+                              common_name="test_update_before", type_id=ROOT_CA_ID, parent_id=-1,
+                              private_key_id=private_key_id,usages={CA_ID: True})
     certificate_id = certificate_repository.create(certificate=certificate)
 
     assert type(certificate_id) is int
@@ -118,18 +146,25 @@ def test_update(certificate_repository, private_key_repository_unique):
     certificate = certificate_repository.read(certificate_id=certificate_id)
 
     assert certificate.certificate_id == certificate_id
-    assert certificate.common_name == "test_update_before"
     assert certificate.valid_from == "test_from"
     assert certificate.valid_to == "test_to"
-    assert certificate.private_key_id == private_key_id
+    assert certificate.pem_data == "test_pem_data"
     assert certificate.type_id == ROOT_CA_ID
     assert certificate.parent_id == certificate_id
+    assert certificate.private_key_id == private_key_id
+    assert certificate.common_name == "test_update_before"
+    assert certificate.country_code is None
+    assert certificate.locality is None
+    assert certificate.province is None
+    assert certificate.organization is None
+    assert certificate.organizational_unit is None
+    assert certificate.email_address is None
+    assert certificate.revocation_date is None
+    assert certificate.revocation_reason is None
     assert certificate.usages[CA_ID]
     assert not certificate.usages[SSL_ID]
     assert not certificate.usages[SIGNATURE_ID]
     assert not certificate.usages[AUTHENTICATION_ID]
-    assert certificate.revocation_date == ""
-    assert certificate.revocation_reason == ""
 
     certificate.common_name = "test_update_after"
     certificate.usages[SSL_ID] = True
@@ -141,18 +176,25 @@ def test_update(certificate_repository, private_key_repository_unique):
     certificate = certificate_repository.read(certificate_id=certificate_id)
 
     assert certificate.certificate_id == certificate_id
-    assert certificate.common_name == "test_update_after"
     assert certificate.valid_from == "test_from"
     assert certificate.valid_to == "test_to"
-    assert certificate.private_key_id == private_key_id
+    assert certificate.pem_data == "test_pem_data"
     assert certificate.type_id == ROOT_CA_ID
     assert certificate.parent_id == certificate_id
+    assert certificate.private_key_id == private_key_id
+    assert certificate.common_name == "test_update_after"
+    assert certificate.country_code is None
+    assert certificate.locality is None
+    assert certificate.province is None
+    assert certificate.organization is None
+    assert certificate.organizational_unit is None
+    assert certificate.email_address is None
+    assert certificate.revocation_date is None
+    assert certificate.revocation_reason is None
     assert certificate.usages[CA_ID]
     assert certificate.usages[SSL_ID]
     assert not certificate.usages[SIGNATURE_ID]
     assert not certificate.usages[AUTHENTICATION_ID]
-    assert certificate.revocation_date == ""
-    assert certificate.revocation_reason == ""
 
 
 def test_update_invalid_id(certificate_repository, private_key_repository_unique):
@@ -161,9 +203,9 @@ def test_update_invalid_id(certificate_repository, private_key_repository_unique
 
     assert type(private_key_id) is int
 
-    certificate = Certificate(certificate_id=-1, common_name="test_update_before", valid_from="test_from",
-                              valid_to="test_to", pem_data="test_pem_data", private_key_id=private_key_id,
-                              type_id=ROOT_CA_ID, parent_id=-1, usages={CA_ID: True})
+    certificate = Certificate(certificate_id=-1, valid_from="test_from", valid_to="test_to", pem_data="test_pem_data",
+                              common_name="test_update_before", type_id=ROOT_CA_ID, parent_id=-1,
+                              private_key_id=private_key_id,usages={CA_ID: True})
     certificate_id = certificate_repository.create(certificate=certificate)
 
     assert type(certificate_id) is int
@@ -171,18 +213,25 @@ def test_update_invalid_id(certificate_repository, private_key_repository_unique
     certificate = certificate_repository.read(certificate_id=certificate_id)
 
     assert certificate.certificate_id == certificate_id
-    assert certificate.common_name == "test_update_before"
     assert certificate.valid_from == "test_from"
     assert certificate.valid_to == "test_to"
-    assert certificate.private_key_id == private_key_id
+    assert certificate.pem_data == "test_pem_data"
     assert certificate.type_id == ROOT_CA_ID
     assert certificate.parent_id == certificate_id
+    assert certificate.private_key_id == private_key_id
+    assert certificate.common_name == "test_update_before"
+    assert certificate.country_code is None
+    assert certificate.locality is None
+    assert certificate.province is None
+    assert certificate.organization is None
+    assert certificate.organizational_unit is None
+    assert certificate.email_address is None
+    assert certificate.revocation_date is None
+    assert certificate.revocation_reason is None
     assert certificate.usages[CA_ID]
     assert not certificate.usages[SSL_ID]
     assert not certificate.usages[SIGNATURE_ID]
     assert not certificate.usages[AUTHENTICATION_ID]
-    assert certificate.revocation_date == ""
-    assert certificate.revocation_reason == ""
 
     certificate.common_name = "test_update_after"
     certificate.usages[SSL_ID] = True
@@ -195,18 +244,25 @@ def test_update_invalid_id(certificate_repository, private_key_repository_unique
     certificate = certificate_repository.read(certificate_id=certificate_id)
 
     assert certificate.certificate_id == certificate_id
-    assert certificate.common_name == "test_update_before"
     assert certificate.valid_from == "test_from"
     assert certificate.valid_to == "test_to"
-    assert certificate.private_key_id == private_key_id
+    assert certificate.pem_data == "test_pem_data"
     assert certificate.type_id == ROOT_CA_ID
     assert certificate.parent_id == certificate_id
+    assert certificate.private_key_id == private_key_id
+    assert certificate.common_name == "test_update_before"
+    assert certificate.country_code is None
+    assert certificate.locality is None
+    assert certificate.province is None
+    assert certificate.organization is None
+    assert certificate.organizational_unit is None
+    assert certificate.email_address is None
+    assert certificate.revocation_date is None
+    assert certificate.revocation_reason is None
     assert certificate.usages[CA_ID]
     assert not certificate.usages[SSL_ID]
     assert not certificate.usages[SIGNATURE_ID]
     assert not certificate.usages[AUTHENTICATION_ID]
-    assert certificate.revocation_date == ""
-    assert certificate.revocation_reason == ""
 
 
 def test_delete(certificate_repository, private_key_repository_unique):
@@ -215,14 +271,14 @@ def test_delete(certificate_repository, private_key_repository_unique):
 
     assert type(private_key_id) is int
 
-    certificate_1 = Certificate(certificate_id=-1, common_name="test_delete_1", valid_from="test_from",
-                              valid_to="test_to", pem_data="test_pem_data", private_key_id=private_key_id,
-                              type_id=ROOT_CA_ID, parent_id=-1, usages={CA_ID: True})
+    certificate_1 = Certificate(certificate_id=-1, valid_from="test_from", valid_to="test_to", pem_data="test_pem_data",
+                                common_name="test_delete_1", type_id=ROOT_CA_ID, parent_id=-1,
+                                private_key_id=private_key_id, usages={CA_ID: True})
     certificate_id_1 = certificate_repository.create(certificate=certificate_1)
 
-    certificate_2 = Certificate(certificate_id=-1, common_name="test_delete_2", valid_from="test_from",
-                                valid_to="test_to", pem_data="test_pem_data", private_key_id=private_key_id,
-                                type_id=ROOT_CA_ID, parent_id=-1, usages={CA_ID: True})
+    certificate_2 = Certificate(certificate_id=-1, valid_from="test_from", valid_to="test_to", pem_data="test_pem_data",
+                                common_name="test_delete_2", type_id=ROOT_CA_ID, parent_id=-1,
+                                private_key_id=private_key_id, usages={CA_ID: True})
     certificate_id_2 = certificate_repository.create(certificate=certificate_2)
 
     assert type(certificate_id_1) is int
@@ -256,9 +312,9 @@ def test_set_certificate_revoked(certificate_repository, private_key_repository_
 
     assert type(private_key_id) is int
 
-    certificate = Certificate(certificate_id=-1, common_name="test_common_name", valid_from="test_from",
-                              valid_to="test_to", pem_data="test_pem_data", private_key_id=private_key_id,
-                              type_id=ROOT_CA_ID, parent_id=-1, usages={CA_ID: True})
+    certificate = Certificate(certificate_id=-1, valid_from="test_from", valid_to="test_to", pem_data="test_pem_data",
+                              common_name="test_common_name", type_id=ROOT_CA_ID, parent_id=-1,
+                              private_key_id=private_key_id, usages={CA_ID: True})
     certificate_id = certificate_repository.create(certificate)
 
     assert type(certificate_id) is int
@@ -266,8 +322,8 @@ def test_set_certificate_revoked(certificate_repository, private_key_repository_
     certificate = certificate_repository.read(certificate_id)
 
     assert certificate.parent_id == certificate_id
-    assert certificate.revocation_date == ""
-    assert certificate.revocation_reason == ""
+    assert certificate.revocation_date is None
+    assert certificate.revocation_reason is None
 
     check_revoked = certificate_repository.set_certificate_revoked(
         certificate_id=certificate_id, revocation_date="test_rev_date_1")
@@ -297,9 +353,9 @@ def test_clear_certificate_revocation(certificate_repository, private_key_reposi
 
     assert type(private_key_id) is int
 
-    certificate = Certificate(certificate_id=-1, common_name="test_common_name", valid_from="test_from",
-                              valid_to="test_to", pem_data="test_pem_data", private_key_id=private_key_id,
-                              type_id=ROOT_CA_ID, parent_id=-1, usages={CA_ID: True})
+    certificate = Certificate(certificate_id=-1, valid_from="test_from", valid_to="test_to", pem_data="test_pem_data",
+                              common_name="test_common_name", type_id=ROOT_CA_ID, parent_id=-1,
+                              private_key_id=private_key_id, usages={CA_ID: True})
     certificate_id = certificate_repository.create(certificate=certificate)
 
     assert type(certificate_id) is int
@@ -307,8 +363,8 @@ def test_clear_certificate_revocation(certificate_repository, private_key_reposi
     certificate = certificate_repository.read(certificate_id=certificate_id)
 
     assert certificate.parent_id == certificate_id
-    assert certificate.revocation_date == ""
-    assert certificate.revocation_reason == ""
+    assert certificate.revocation_date is None
+    assert certificate.revocation_reason is None
 
     check_revoked = certificate_repository.set_certificate_revoked(
         certificate_id=certificate_id, revocation_date="test_rev_date_1")
@@ -326,8 +382,8 @@ def test_clear_certificate_revocation(certificate_repository, private_key_reposi
 
     certificate = certificate_repository.read(certificate_id=certificate_id)
 
-    assert certificate.revocation_date == ""
-    assert certificate.revocation_reason == ""
+    assert certificate.revocation_date is None
+    assert certificate.revocation_reason is None
 
 
 def test_get_all_revoked_by(certificate_repository, private_key_repository_unique):
@@ -336,9 +392,9 @@ def test_get_all_revoked_by(certificate_repository, private_key_repository_uniqu
 
     assert type(private_key_id) is int
 
-    certificate = Certificate(certificate_id=-1, common_name="test_common_name", valid_from="test_from",
-                              valid_to="test_to", pem_data="test_pem_data", private_key_id=private_key_id,
-                              type_id=ROOT_CA_ID, parent_id=-1, usages={CA_ID: True})
+    certificate = Certificate(certificate_id=-1, valid_from="test_from", valid_to="test_to", pem_data="test_pem_data",
+                              common_name="test_common_name", type_id=ROOT_CA_ID, parent_id=-1,
+                              private_key_id=private_key_id, usages={CA_ID: True})
     certificate_id = certificate_repository.create(certificate=certificate)
 
     assert type(certificate_id) is int
@@ -360,9 +416,9 @@ def test_get_all_revoked_by(certificate_repository, private_key_repository_uniqu
     certificate_repository.set_certificate_revoked(
         certificate_id=child_3_id, revocation_date="test_revoke_child_3", revocation_reason="test_parent")
 
-    sec_tree_certificate = Certificate(certificate_id=-1, common_name="test_sec_tree", valid_from="test_from",
-                                       valid_to="test_to", pem_data="test_pem_data", private_key_id=private_key_id,
-                                       type_id=ROOT_CA_ID, parent_id=-1, usages={CA_ID: True})
+    sec_tree_certificate = Certificate(certificate_id=-1, valid_from="test_from", valid_to="test_to",
+                                       pem_data="test_pem_data", common_name="test_sec_tree", type_id=ROOT_CA_ID,
+                                       parent_id=-1, private_key_id=private_key_id, usages={CA_ID: True})
     sec_tree_certificate_id = certificate_repository.create(certificate=sec_tree_certificate)
 
     assert type(sec_tree_certificate_id) is int
@@ -397,9 +453,9 @@ def test_get_all_issued_by(certificate_repository, private_key_repository_unique
 
     assert type(private_key_id) is int
 
-    certificate = Certificate(certificate_id=-1, common_name="test_common_name", valid_from="test_from",
-                              valid_to="test_to", pem_data="test_pem_data", private_key_id=private_key_id,
-                              type_id=ROOT_CA_ID, parent_id=-1, usages={CA_ID: True})
+    certificate = Certificate(certificate_id=-1, valid_from="test_from", valid_to="test_to", pem_data="test_pem_data",
+                              common_name="test_common_name", type_id=ROOT_CA_ID, parent_id=-1,
+                              private_key_id=private_key_id, usages={CA_ID: True})
     certificate_id = certificate_repository.create(certificate=certificate)
 
     assert type(certificate_id) is int
@@ -421,9 +477,9 @@ def test_get_all_issued_by(certificate_repository, private_key_repository_unique
     certificate_repository.set_certificate_revoked(
         certificate_id=child_3_id, revocation_date="test_revoke_child_3", revocation_reason="test_parent")
 
-    sec_tree_certificate = Certificate(certificate_id=-1, common_name="test_sec_tree", valid_from="test_from",
-                                       valid_to="test_to", pem_data="test_pem_data", private_key_id=private_key_id,
-                                       type_id=ROOT_CA_ID, parent_id=-1, usages={CA_ID: True})
+    sec_tree_certificate = Certificate(certificate_id=-1, valid_from="test_from", valid_to="test_to",
+                                       pem_data="test_pem_data", common_name="test_sec_tree", type_id=ROOT_CA_ID,
+                                       parent_id=-1, private_key_id=private_key_id, usages={CA_ID: True})
     sec_tree_certificate_id = certificate_repository.create(certificate=sec_tree_certificate)
 
     assert type(sec_tree_certificate_id) is int
diff --git a/tests/unit_tests/services/crl/ca_index_file_line_generator_test.py b/tests/unit_tests/services/crl/ca_index_file_line_generator_test.py
index ea0570e..49472b3 100644
--- a/tests/unit_tests/services/crl/ca_index_file_line_generator_test.py
+++ b/tests/unit_tests/services/crl/ca_index_file_line_generator_test.py
@@ -7,7 +7,10 @@ from src.services.crl_ocsp.ca_index_file_line_generator import create_index_file
 
 def test_get_index_file_time_entry_valid():
     cert = Certificate(
-        1, "Foo", "21.03.2020", "21.03.2021", "", -1, -1, -1, {}, "02.02.2021", "keyCompromise"
+        1, "21.03.2020", "21.03.2021", "", -1, -1, -1, {},
+        common_name="Foo",
+        revocation_date="02.02.2021",
+        revocation_reason="keyCompromise"
     )
 
     date_format = "%d.%m.%Y"
@@ -26,7 +29,10 @@ def test_get_index_file_time_entry_valid():
 
 def test_get_index_file_time_entry_valid_2():
     cert = Certificate(
-        101024, "Bar", "01.01.2019", "06.10.2021", "", -1, -1, -1, {}, "03.09.2021", "affiliationChanged"
+        101024, "01.01.2019", "06.10.2021", "", -1, -1, -1, {},
+        common_name="Bar",
+        revocation_date="03.09.2021",
+        revocation_reason="affiliationChanged"
     )
 
     date_format = "%d.%m.%Y"
@@ -45,7 +51,10 @@ def test_get_index_file_time_entry_valid_2():
 
 def test_get_index_file_time_entry_valid_3():
     cert = Certificate(
-        1, "IA CA", "", "01.04.2023 15:01:11", "", -1, -1, -1, {}, "01.04.2021 15:12:00", "keyCompromise"
+        1, "", "01.04.2023 15:01:11", "", -1, -1, -1, {},
+        common_name="IA CA",
+        revocation_date="01.04.2021 15:12:00",
+        revocation_reason="keyCompromise"
     )
 
     date_format = "%d.%m.%Y %H:%M:%S"
@@ -67,7 +76,8 @@ def test_get_index_file_time_entry_valid_3():
 
 def test_get_index_file_valid_line():
     cert = Certificate(
-        1, "IA CA", "", "01.04.2023 15:01:11", "", -1, -1, -1, {}, "", ""
+        1, "", "01.04.2023 15:01:11", "", -1, -1, -1, {},
+        common_name="IA CA"
     )
 
     date_format = "%d.%m.%Y %H:%M:%S"
diff --git a/tests/unit_tests/services/crl/generate_crl_test.py b/tests/unit_tests/services/crl/generate_crl_test.py
index 5ace521..055bf6b 100644
--- a/tests/unit_tests/services/crl/generate_crl_test.py
+++ b/tests/unit_tests/services/crl/generate_crl_test.py
@@ -123,8 +123,7 @@ XlFRZbGV9ivNg6kM4L/7LgNTgBA5T63f
 def test_generate_crl():
     # only PEM data are relevant for the testcase
     service = CryptographyService()
-    cert = Certificate(-1, "", "", "",
-                       CERTIFICATE_PEM, -1, -1, -1, {})
+    cert = Certificate(-1, "", "", CERTIFICATE_PEM, -1, -1, -1, {}, "")
     key = PrivateKey(-1, KEY_PEM)
     # generate CRL
     with TemporaryFile("index", INDEX) as index_file: